> For the complete documentation index, see [llms.txt](https://docs.servoy.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.servoy.com/reference/servoy-developer/menu/refactor.md).

# Refactor

User manual for Servoy Developer Refactor Menu items

## Overview

This menu item is available only when a script editor is active.\
It is important to note that for refactoring to work comprehensively, the code must be properly documented through JSDoc. Insufficient information will result in decreased usefulness of the refactoring functionality.\
When performing a refactoring operation, a window will appear, allowing users to specify the required information and preview all the changes that will be made in all the code.

## Commands Summary

A summary of commands available via clicking on this menu item:

| Command              | Summary                                                                                          |
| -------------------- | ------------------------------------------------------------------------------------------------ |
| [Rename...](#rename) | Renames variables (global, form and local - within functions), functions and function parameters |
| [Move...](#move)     | Opens the [Move](/reference/servoy-developer/object-editors/refactor-move-wizard.md) wizard      |

## Commands Details

The details for each command available via clicking on this menu item:

### Rename

keybinding: `Alt+Shift+R`\
Opens a window where the user can insert a new name.\
Renames variables (global, form and local - within functions), functions and function parameters. The rename refactor changes the name both for the declaration of the object to be renamed, as well as all references to the object.

{% hint style="warning" %}
This operation is available if the users selects a Script project, source folder, resource, package or a source module, a non-binary type, field, method, parameter, local variable or type variable.
{% endhint %}

### Move

Opens the [Move](/reference/servoy-developer/object-editors/refactor-move-wizard.md) wizard.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.servoy.com/reference/servoy-developer/menu/refactor.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
